#ifndef RTS_ENTITY_HEALTH_HPP
#define RTS_ENTITY_HEALTH_HPP

#include <godot_cpp/classes/node.hpp>

namespace gd = godot;

class Unit;

class EntityHealth : public gd::Node {
    GDCLASS(EntityHealth, gd::Node);
    static void _bind_methods();
public:
    virtual void _enter_tree() override;
    void damaged_by(int amount, Unit *source);
    void damage(int amount);
    void healed_by(int amount, Unit *source);
    void heal(int amount);
    void set_max_health(int max_health);
    int get_max_health() const;
    void set_current_health(int current_health);
    int get_current_health() const;
private:
    int max_health{100};
    int current_health{0};
};

#endif // !RTS_ENTITY_HEALTH_HPP
